/*
 * Created on Sep 12, 2004
 */
package org.tekkotsu.ui.editor.model;

/**
 * AbstractModel containing property control methods
 * @author asangpet
 */

import java.beans.PropertyChangeSupport;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.jdom.Content;

abstract public class AbstractModel implements IPropertySource {
	public PropertyChangeSupport props = new PropertyChangeSupport(this);
	private AbstractModel parent;
	
	public static final String PROPERTIES_MODEL_CATEGORY = "Info";
    public static final String PROPERTIES_APPEARANCE_CATEGORY = "Display";
	
	public void setParent(AbstractModel parent) {
		this.parent = parent;
	}
	
	public AbstractModel getParent() {
		return parent;
	}
	
	public Object getEditableValue() {
		return this;
	}
	
	public Object getPropertyValue(Object id) {
		return null;
	}
	
	public boolean isPropertySet(Object id) {
		return false;
	}
	
	public IPropertyDescriptor[] getPropertyDescriptors() {
		return new IPropertyDescriptor[0];
	}
	
	public void resetPropertyValue(Object id) {
		//default of do nothing
	}
	public void setPropertyValue(Object id, Object value) {
		//default of do nothing
	}
	
	public void doPreDelete(LayoutData contents)
    {
    	//nothing by default
    }
	
	/**
	 * Generate XML code representation of this model
	 * @return
	 */
	abstract public Content getXML();
	abstract public boolean isPreview();
	
	public void activate() {
		props.firePropertyChange(StateNodeModel.P_ACTIVATE, null, null);
	}
	public void deactivate() {
		props.firePropertyChange(StateNodeModel.P_DEACTIVATE, null, null);
	}
}
