package org.tekkotsu.ui.storyboard.model;

import org.tekkotsu.ui.storyboard.views.RuntimeView;
import org.tekkotsu.ui.storyboard.views.RuntimeView.TreeObject;
import org.tekkotsu.ui.storyboard.views.RuntimeView.TreeParent;

import static org.tekkotsu.ui.storyboard.views.RuntimeView.timeToString;

public class LogModel extends AbstractModel {
	String icon="__fallback__.png";
	String content = "";
	String etid = "";
	String egid = null;

	public LogModel(String sid, int start, String iconName, String etid, String egid, String content) {
		super(start,start,sid,start,start, true);
		if (iconName!=null) icon = ( iconName.endsWith(".png") ? iconName : iconName + ".png");
		if (content!=null) this.content = content;
		if (etid!=null) this.etid = etid; else this.etid = ETID_ACTIVATE;
		if (egid!=null) this.egid = egid;
	}
	
	public int getTime() {
		return start;
	}
	
	public String getIconName() {
		return icon;
	}
	
	public String getContent() {
		return content;
	}
	
	public String getETID() {
	    return etid;
	}
	
	public String getETIDString() {
	    if (ETID_ACTIVATE.equals(etid)) return "Activate";
	    if (ETID_DEACTIVATE.equals(etid)) return "Deactivate";
	    if (ETID_STATUS.equals(etid)) return "Status";
	    return "Unknown";
	}
    
    @Override
	public RuntimeView.TreeObject getRuntimeViewData() {
    	TreeParent par = new TreeParent("log sid: " + getID(),getTime(),getTime());
		par.addChild(new TreeObject("type: log"));
		if( egid != null ) {
			par.addChild(new TreeObject("egid: " + egid));
		}
		par.addChild(new TreeObject("report at: "+timeToString(getTime())));
		if( content != null ) {
			String trimmedContent = content.trim();
			if( !trimmedContent.isEmpty() ) {

				par.addChild(new TreeObject("message: " + trimmedContent));
			}
		}
		return par;
	}
}
